
#ifndef __HAIR__H
#define __HAIR__H


#include "prim.h"
#include "iparamm.h"
#include "Simpobj.h"
#include "texutil.h"
#include "istdplug.h"
#include "decomp.h"
#include "trig.h"
#include "bmmlib.h"
#include "splshape.h"
#include "simpspl.h"



///#include "..\mgraph\mgraph.h"

//Martin Foster ID
//#define BETAID 1


//Glenn Melenhorst ID
//#define BETAID 2

//Paul Hormis ID
#define BETAID 3

//Johnny OW ID
//#define BETAID 4

//Ian Christie ID	 
//#define BETAID 5


//Blur Studio ID
//#define BETAID 6

//Steven Bodnar
//#define BETAID 7

//Hugues Giboire
//#define BETAID 8



#define MGRAPH_CLASSID	Class_ID(0x73ca3b9a, 0x4d712dc2)

#define PW_SNOW_CLASS_ID 0x5b8e36a5

// One Reference:
#define PBLOCK_REF		0
#define OBJECT_REF		1
#define WIDTHOBJECT_REF	2
#define SECONDARYOBJECT_REF	3
#define MOTIONOBJECT_REF	4
#define SPLINECAGEOBJECT_REF	5
#define VERTEXDEFORMATIONOBJECT_REF	6
#define CLUMPINGOBJECT_REF	7

#define CM_OBJECT_REF 0


#define MAPNAME_LENGTH_CHUNK	0x0100
#define BMIO_LENGTH_CHUNK		0x0200

#define MAPNAME_DISTRIBUTION_CHUNK	0x0300
#define BMIO_DISTRIBUTION_CHUNK		0x0400


#define MAPNAME_CLUMP_CHUNK	0x0300
#define BMIO_CLUMP_CHUNK		0x0400

//class RectangleObject;

class NullView: public View {
	public:
		Point2 ViewToScreen(Point3 p) { return Point2(p.x,p.y); }
		NullView() { worldToView.IdentityMatrix(); screenW=640.0f; screenH = 480.0f; }
	};


class VertexType{

public:
	Point3 Pos,uvw;
	Point3 pNormal;
	char used;
	int AttachedToFace;

	};


class StartPosClass
	{
public:
	Point3 pos,prevpos,vel,prevnormal,uvw;
	Point3 JitterRandom;
	int Group;
	float StrandLength;
	Tab<float> PercentControl;
	Tab<float> DistToSpline;
	int AttachedToFace;
	BOOL cutted,on,use_filler;
	int seed;
	};

class FillerClass
	{
public:
	Tab<Point3> OffsetList;
	Tab<int> SegmentList;
	};

class SplineData
{
public:
	Tab<Point3> Velocities;
};





class GenParticle : public SimpleParticle {
	public:

		float swidth,sheight;
		int HCount;
		int NumberStrands;
		int LastParticle;
		int NumberOfSplines;
		Tab<StartPosClass> Starting;
		Tab<Point3> SplineStartingVerts;
		Tab<Point3> SplineStartingVertsTransformed;

		Tab<Point3>StartingVelTransFormed;


		Tab<VertexType> DVerts;

		Tab<Point3> SecondaryMotion;

		Tab<SplineData> SplineVelocityList;

		Tab<FillerClass> FillerData;


		Tab<float> SplineLengths;




		Matrix3 EmitterTM,SplineTM;
		BOOL Still,PrevStill,UseJiggle;
		Matrix3 PrevEmitterTM;
		TimeValue SwingTime;
		TimeValue JiggleTime;
		int Settle,Waves;
		float Affect;



		Bitmap *thebmLength;
		BitmapInfo biLength;

		Bitmap *thebmDistribution;
		BitmapInfo biDistribution;

		void FreeBitmap();
		void LoadBitmap();
		float GetLengthPixel(float u, float v);

		void FreeDistributionBitmap();
		void LoadDistributionBitmap();
		float GetDistributionPixel(float u, float v);

		~GenParticle();
		float CompParticleSize(TimeValue t, TimeValue age, TimeValue life, float size);


		int AddPoints(Point3 v1, Point3 n1, Point3 TV1, Point3 v2, Point3 n2, Point3 TV2, Point3 v3, Point3 n3, Point3 TV3, int depth, int face);

		int AddPoint(Point3 v,Point3 n, Point3 uvw, BOOL check,int face);

		Point3 GetNormal(RVertex *n);

		void BuildVerts(TimeValue t);

		void BuildStartingPos(BOOL RecreateEverything,TimeValue bt);

		BOOL IsVertSelected(int VertID, Mesh *mesh, int& face);

		static IParamMap *pmapParam;		
		int stepSize;

		IObjParam *Tempip;

		INode *ObjectNode;
		INode *WidthGraphNode;
		INode *SecondaryGraphNode;
		INode *MotionGraphNode;
		INode *VertexDeformationGraphNode;
		
		INode *ClumpingGraphNode;

		INode *SplineCageNode;

		GenParticle(BOOL rain);


		int RemoveStrands(View& view,TimeValue t,Matrix3 tm, int& AdditionSegs, int& AdditionNumber);

		void BuildSplineCageData(TimeValue t);
		void BuildSplineCagePercentData(TimeValue t);
		Point3 GetSplineVelocity(int j, TimeValue t);

		float GetGraph(int Index, TimeValue t, float pos);

		void SetLengthImageTime(TimeValue t);


//particle manip stuff
		void DoEmitterCollision();
		void DoNormalization(int CActive, int CFrame, TimeValue life, TimeValue dt);
		void DoClumping(TimeValue life, float MaxLength, float Falloff);


		void BirthParticle(INode *node,TimeValue bt,int index, Matrix3 stm);
		void ComputeParticleStart(TimeValue t0,INode *node);
		int CountLive();
		Mesh *GetFacingRenderMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		int	GetParticleCount();		
		int	GetStrandCount();		

		// From BaseObject
		CreateMouseCallBack* GetCreateMouseCallBack();
		void BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev);		
		void EndEditParams( IObjParam *ip, ULONG flags,Animatable *next);		
		void GetWorldBoundBox(TimeValue t, INode *inode, ViewExp* vpt, Box3& box);
			
		// Animatable methods		
		void DeleteThis() {delete this;}

		IOResult Load(ILoad *iload);
		IOResult Save(ISave *isave);



		void MapKeys(TimeMap *map,DWORD flags);
		int RenderBegin(TimeValue t, ULONG flags);		
		int RenderEnd(TimeValue t);
		
		// From SimpleParticle
		void UpdateParticles(TimeValue t,INode *node);
		void BuildEmitter(TimeValue t, Mesh& amesh);
		Interval GetValidity(TimeValue t);		
		void InvalidateUI();
		ParamDimension *GetParameterDim(int pbIndex);
		TSTR GetParameterName(int pbIndex);
		BOOL EmitterVisible();		

		virtual int DialogID()=0;
		virtual ParamUIDesc *ParamDesc()=0;
		virtual int DescCount()=0;

	// ReferenceMaker methods:
		int NumSubs() {return 1;}
		Animatable* SubAnim(int i) {return pblock;}
		TSTR SubAnimName(int i) {return _T("");}
		int NumRefs() {return 8;}
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
    		PartID& partID,  RefMessage message);		


/*		int NumRefs () { return 1; }
		RefTargetHandle GetReference (int i);
		void SetReference (int i, RefTargetHandle rtarg);
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
    		PartID& partID,  RefMessage message);		

*/

	};




class SnowParticle;

class SnowParticleDraw : public CustomParticleDisplay {
	public:
		float scale, tumble;
		int  LParticle,NParticles,Alive;
		TimeValue life;
		SnowParticle *obj;
		int ptype;
		SnowParticleDraw() {obj=NULL;}
		BOOL DrawParticle(GraphicsWindow *gw,ParticleSys &parts,int i);
	};




class SnowParticle : public GenParticle {
	public:




		SnowParticle();


		SnowParticleDraw theSnowDraw;

		// From BaseObject
		TCHAR *GetObjectName() {return GetString(IDS_RB_SNOW);}
		
		// From GeomObject
		Mesh* GetRenderMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		Mesh *GetPlusMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		Mesh *GetHairMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		Mesh *GetHairOneSidedMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		Mesh *GetWireMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		Mesh *GetNullMesh(TimeValue t, INode *inode, View& view, BOOL& needDelete);
		int IsInstanceDependent() {return 1;}

		// Animatable methods				
		Class_ID ClassID() {return Class_ID(PW_SNOW_CLASS_ID,0);} 

		// From ref
		RefTargetHandle Clone(RemapDir& remap = NoRemap());		

		// From SimpleParticle
		MarkerType GetMarkerType();		
		void UpdateParticles(TimeValue t,INode *node);

		int DialogID() {return IDD_SNOWPARAM;}
		ParamUIDesc *ParamDesc();
		int DescCount();

		Matrix3 TumbleMat(int index,float amount, float scale);
	
	};


//--- ClassDescriptor and class vars ---------------------------------


class SnowClassDesc:public ClassDesc {
	public:
	int 			IsPublic() {return 1;}
	void *			Create(BOOL loading = FALSE) {return new SnowParticle;}
	const TCHAR *	ClassName() {return GetString(IDS_RB_SNOW);}
	SClass_ID		SuperClassID() {return GEOMOBJECT_CLASS_ID;}
	Class_ID		ClassID() {return Class_ID(PW_SNOW_CLASS_ID,0);}
	const TCHAR* 	Category() {return GetString(IDS_RB_PARTICLESYSTEMS);}
	};




//--- Parameter map/block descriptors -------------------------------

#define RAINSIZEFACTOR (float(TIME_TICKSPERSEC)/120.0f)
#define PARTICLE_SEED	0x8d6a65bc


#define PB_VPTPARTICLES		0
#define PB_RNDPARTICLES		1
#define PB_DROPSIZE			2
#define PB_SPEED			3
#define PB_CUTTERFRAME		4
#define PB_TUMBLE			5
#define PB_SCALE			6
#define PB_DISPTYPE			7
#define PB_STARTTIME		8
#define PB_SEGCOUNT			9
#define PB_EMITTERWIDTH		10
#define PB_EMITTERHEIGHT	11
#define PB_HIDEEMITTER		12
#define PB_SECONDARY		13
#define PB_WATJE_FALLOFF	14
#define PB_SETTLE			15
#define PB_MOTIONTRANSFER	16
#define PB_RENDER			17
#define PB_LENGTH_MIN		18
#define PB_LENGTH_MAX		19
#define PB_WSM				20
#define PB_GENERATEW		21
#define PB_VERTEXDEFORMATION 22

#define PB_CLUMPCHANCE		23
#define PB_CLUMP_MIN		24
#define PB_CLUMP_MAX		25
#define PB_CLUMP_RADIUS		26
#define PB_CUTTERACTIVE		27
#define PB_VIEWACTIVE		28
#define PB_RENDERACTIVE		29

#define PB_ABSOLUTE_DIRECTION 30
#define PB_SPLINE_LIMITS	  31
#define PB_MAX_NUMBER_SPLINES 32

#define PB_USE_ANGLE_LIMIT	33
#define PB_ANGLE_LIMIT		34

#define PB_FILLER_MULTIPLIER 35
#define PB_USE_FILLER_ANGLE_LIMIT  36
#define PB_FILLER_ANGLE_LIMIT 37
#define PB_FILLER_DISTANCE   38
#define PB_MIN_FILLER_SEGMENT 39
#define PB_MAX_FILLER_SEGMENT 40

#define PB_USE_SELECTED_FACES 41
#define PB_JITTER 42

#define PB_WAVES 43




// render types
#define RENDTYPE1	0
#define RENDTYPE2	1
#define RENDTYPE3	2
#define RENDTYPE5	3
#define RENDTYPE6   4
#define RENDTYPE7   5
#define RENDTYPE8   6




//para,block stuff


//
// Parameters

static int typeIDs[] = {IDC_PARTICLE_CUST,IDC_PARTICLE_DOTS,IDC_PARTICLE_TICKS,IDC_PARTICLE_TICKS2};
static int rendIDs[] = {IDC_PARTICLE_RD6,
                        IDC_PARTICLE_RD2,
						IDC_PARTICLE_RD3,
						IDC_PARTICLE_RD4,
						IDC_PARTICLE_RD5,
						IDC_PARTICLE_RD7,
						IDC_PARTICLE_RD8
};


static ParamUIDesc descParamSnow[] = {
	// Viewport particles
	ParamUIDesc(
		PB_VPTPARTICLES,
		EDITTYPE_INT,
		IDC_VPT_PARTICLES,IDC_VPT_PARTICLESSPIN,
		1.0f,999999999.0f,
		1.0f),

	// Render particles
	ParamUIDesc(
		PB_RNDPARTICLES,
		EDITTYPE_INT,
		IDC_REND_PARTICLES,IDC_REND_PARTICLESSPIN,
		1.0f,999999999.0f,
		1.0f),

	// Particle size
	ParamUIDesc(
		PB_DROPSIZE,
		EDITTYPE_UNIVERSE,
		IDC_PARTICLE_SIZE,IDC_PARTICLE_SIZESPIN,
		0.0f,999999999.0f,
		SPIN_AUTOSCALE),	

	// Particle speed
	ParamUIDesc(
		PB_SPEED,
		EDITTYPE_FLOAT,
		IDC_PARTICLE_SPEED,IDC_PARTICLE_SPEEDSPIN,
		-999999999.0f,999999999.0f,
		0.005f),

	// Cutter Frame
	ParamUIDesc(
		PB_CUTTERFRAME,
		EDITTYPE_INT,
		IDC_CUTTERFRAME,IDC_CUTTERFRAME_SPIN,
		0.0f,999999999.0f,
		1.0f),

	// Particle Tumble
	ParamUIDesc(
		PB_TUMBLE,
		EDITTYPE_FLOAT,
		IDC_PARTICLE_TUMBLE,IDC_PARTICLE_TUMBLESPIN,
		0.0f,1.0f,
		0.005f),

	// Tumble scale
	ParamUIDesc(
		PB_SCALE,
		EDITTYPE_FLOAT,
		IDC_PARTICLE_SCALE,IDC_PARTICLE_SCALESPIN,
		0.0f,999999999.0f,
		0.01f),

	// Display type
	ParamUIDesc(PB_DISPTYPE,TYPE_RADIO,typeIDs,4),

	// Start time
	ParamUIDesc(
		PB_STARTTIME,
		EDITTYPE_TIME,
		IDC_PARTICLE_START,IDC_PARTICLE_STARTSPIN,
		-999999999.0f,999999999.0f,
		10.0f),

	// Life time
	ParamUIDesc(
		PB_SEGCOUNT,
		EDITTYPE_INT,
		IDC_PARTICLE_SEGCOUNT,IDC_PARTICLE_SEGCOUNTSPIN,
		0.0f,999999999.0f,
		1.0f),


	
	// Emitter width
	ParamUIDesc(
		PB_EMITTERWIDTH,
		EDITTYPE_UNIVERSE,
		IDC_EMITTER_WIDTH,IDC_EMITTER_WIDTHSPIN,
		0.0f,999999999.0f,
		SPIN_AUTOSCALE),	

	// Emitter height
	ParamUIDesc(
		PB_EMITTERHEIGHT,
		EDITTYPE_UNIVERSE,
		IDC_EMITTER_HEIGHT,IDC_EMITTER_HEIGHTSPIN,
		0.0f,999999999.0f,
		SPIN_AUTOSCALE),	

	// Hide Emitter
	ParamUIDesc(PB_HIDEEMITTER,TYPE_SINGLECHEKBOX,IDC_HIDE_EMITTER),

	// Secondary
	ParamUIDesc(PB_SECONDARY,TYPE_SINGLECHEKBOX,IDC_SECONDARY),


	// Falloff
	ParamUIDesc(
		PB_WATJE_FALLOFF,
		EDITTYPE_FLOAT,
		IDC_FALLOFF,IDC_FALLOFFSPIN,
		0.0f,1.0f,
		SPIN_AUTOSCALE),	

	// Settle Frames
	ParamUIDesc(
		PB_SETTLE,
		EDITTYPE_INT,
		IDC_SETTLE,IDC_SETTLE_SPIN,
		0.0f,10000.0f,
		SPIN_AUTOSCALE),	

	// Motion Transfer
	ParamUIDesc(PB_MOTIONTRANSFER,TYPE_SINGLECHEKBOX,IDC_MOTIONTRANSFER),

	
	// Render
	ParamUIDesc(PB_RENDER,TYPE_RADIO,rendIDs,7),

	// Min Length
	ParamUIDesc(
		PB_LENGTH_MIN,
		EDITTYPE_FLOAT,
		IDC_MINLENGTH,IDC_MINLENGTH_SPIN,
		0.0f,10000000.0f,
		SPIN_AUTOSCALE),	

	// Max Length
	ParamUIDesc(
		PB_LENGTH_MAX,
		EDITTYPE_FLOAT,
		IDC_MAXLENGTH,IDC_MAXLENGTH_SPIN,
		0.0f,10000000.0f,
		SPIN_AUTOSCALE),	

	// WSM
	ParamUIDesc(PB_WSM,TYPE_SINGLECHEKBOX,IDC_WSM),

	// W
	ParamUIDesc(PB_GENERATEW,TYPE_SINGLECHEKBOX,IDC_GENERATEW),

	// Vertex Deformation
	ParamUIDesc(PB_VERTEXDEFORMATION,TYPE_SINGLECHEKBOX,IDC_VERTEXDEFORMATION),

	// Clump Chance
	ParamUIDesc(
		PB_CLUMPCHANCE,
		EDITTYPE_FLOAT,
		IDC_CLUMPING,IDC_CLUMPING_SPIN,
		0.0f,1.0f,
		SPIN_AUTOSCALE),	

	// Min Clump
	ParamUIDesc(
		PB_CLUMP_MIN,
		EDITTYPE_INT,
		IDC_MINCLUMPING,IDC_MINCLUMPING_SPIN,
		0.0f,10000000.0f,
		SPIN_AUTOSCALE),	

	// Max Clump
	ParamUIDesc(
		PB_CLUMP_MAX,
		EDITTYPE_INT,
		IDC_MAXCLUMPING,IDC_MAXCLUMPING_SPIN,
		0.0f,10000000.0f,
		SPIN_AUTOSCALE),	

	// Clumping Radius
	ParamUIDesc(
		PB_CLUMP_RADIUS,
		EDITTYPE_FLOAT,
		IDC_CLUMPING_RADIUS,IDC_CLUMPING_RADIUS_SPIN,
		0.0f,10000000.0f,
		SPIN_AUTOSCALE),	

	// Cutter ACtive
	ParamUIDesc(PB_CUTTERACTIVE,TYPE_SINGLECHEKBOX,IDC_CUTTERACTIVE_CHECK),

	// View ACtive
	ParamUIDesc(PB_VIEWACTIVE,TYPE_SINGLECHEKBOX,IDC_VIEWPORTACTIVE_CHECK),

	// Render ACtive
	ParamUIDesc(PB_RENDERACTIVE,TYPE_SINGLECHEKBOX,IDC_RENDERACTIVE_CHECK),

	// Absolute Direction
	ParamUIDesc(PB_ABSOLUTE_DIRECTION,TYPE_SINGLECHEKBOX,IDC_ABSOLUTE_DIRECTION),


	// Spline Limit
	ParamUIDesc(PB_SPLINE_LIMITS,TYPE_SINGLECHEKBOX,IDC_SPLINE_LIMITS),

	// Max Number of Spline
	ParamUIDesc(
		PB_MAX_NUMBER_SPLINES,
		EDITTYPE_INT,
		IDC_MAX_NUMBER_SPLINES,IDC_MAX_NUMBER_SPLINES_SPIN,
		1.0f,10000000.0f,
		SPIN_AUTOSCALE),	





	// use Angle Limit
	ParamUIDesc(PB_USE_ANGLE_LIMIT,TYPE_SINGLECHEKBOX,IDC_ANGLE_LIMIT_CHECK),

	// Limit Angle
	ParamUIDesc(
		PB_ANGLE_LIMIT,
		EDITTYPE_INT,
		IDC_ANGLE_LIMIT,IDC_ANGLE_LIMIT_SPIN,
		-180.0f,180.0f,
		SPIN_AUTOSCALE),	




	// Filler Mult
	ParamUIDesc(
		PB_FILLER_MULTIPLIER,
		EDITTYPE_INT,
		IDC_FILLER_COUNT,IDC_FILLER_COUNT_SPIN,
		0.0f,180.0f,
		SPIN_AUTOSCALE),	

	// Filler Limit Angle
	ParamUIDesc(
		PB_FILLER_ANGLE_LIMIT,
		EDITTYPE_INT,
		IDC_FILLER_ANGLE_LIMIT,IDC_FILLER_ANGLE_LIMIT_SPIN,
		-100.0f,100.0f,
		SPIN_AUTOSCALE),	

	// use Filler Angle Limit
	ParamUIDesc(PB_USE_FILLER_ANGLE_LIMIT,TYPE_SINGLECHEKBOX,IDC_FILLER_ANGLE_LIMIT_CHECK),

	// Distance
	ParamUIDesc(
		PB_FILLER_DISTANCE,
		EDITTYPE_FLOAT,
		IDC_FILLER_DISTANCE,IDC_FILLER_DISTANCE_SPIN,
		0.0f,100000.0f,
		SPIN_AUTOSCALE),	

	// Min Segments
	ParamUIDesc(
		PB_MIN_FILLER_SEGMENT,
		EDITTYPE_INT,
		IDC_MIN_FILLER_SEGMENTS,IDC_MIN_FILLER_SEGMENTS_SPIN,
		2.0f,100000.0f,
		SPIN_AUTOSCALE),	

	// Max Segments
	ParamUIDesc(
		PB_MAX_FILLER_SEGMENT,
		EDITTYPE_INT,
		IDC_MAX_FILLER_SEGMENTS,IDC_MAX_FILLER_SEGMENTS_SPIN,
		2.0f,100000.0f,
		SPIN_AUTOSCALE),	


	// use Selected Faces
	ParamUIDesc(PB_USE_SELECTED_FACES,TYPE_SINGLECHEKBOX,IDC_SELECTED_FACES),

	// Jitter
	ParamUIDesc(
		PB_JITTER,
		EDITTYPE_FLOAT,
		IDC_JITTER,IDC_JITTER_SPIN,
		0.0f,100000.0f,
		SPIN_AUTOSCALE),	

	// Waves
	ParamUIDesc(
		PB_WAVES,
		EDITTYPE_INT,
		IDC_WAVE,IDC_WAVE_SPIN,
		0.0f,100000.0f,
		SPIN_AUTOSCALE),	



	};



static ParamBlockDescID descVer0[] = {
	{ TYPE_INT, NULL, FALSE, 0 },	// vpt count
	{ TYPE_INT, NULL, FALSE, 1 },	// rnd count	
	{ TYPE_FLOAT, NULL, TRUE, 2 },	// size
	{ TYPE_FLOAT, NULL, TRUE, 3 },	// speed
	{ TYPE_INT, NULL, TRUE, 4 },	// Cutter  Frame
	{ TYPE_FLOAT, NULL, TRUE, 5 },	// tumble
	{ TYPE_FLOAT, NULL, TRUE, 6 },	// tumble scale

	{ TYPE_INT, NULL, FALSE, 7 },	// viewport type	
	{ TYPE_INT, NULL, FALSE, 8 },	// start
	{ TYPE_INT, NULL, FALSE, 9 },	// life
	{ TYPE_INT, NULL, FALSE, 10 },	// secondary

	{ TYPE_FLOAT, NULL, TRUE, 11 },	// width
	{ TYPE_FLOAT, NULL, TRUE, 12 },	// height
	{ TYPE_INT, NULL, FALSE, 13 },	// hide emitter
	{ TYPE_FLOAT, NULL, TRUE, 14  },// falloff
	{ TYPE_FLOAT, NULL, TRUE, 15  },// secondary motion
	{ TYPE_INT, NULL, FALSE, 16 },	// Motion Transfer
	{ TYPE_INT, NULL, FALSE, 17 },	// render type
	{ TYPE_FLOAT, NULL, FALSE, 18 },	// min Length
	{ TYPE_FLOAT, NULL, FALSE, 19 },	// max Length
	{ TYPE_INT, NULL, FALSE, 20 },	// wsm
	{ TYPE_INT, NULL, FALSE, 21 },	// generate w mapping
	{ TYPE_INT, NULL, FALSE, 22 },	// vertex deformation
	{ TYPE_FLOAT, NULL, FALSE, 23 },	// Clump chance
	{ TYPE_INT, NULL, FALSE, 24 },	// min clump
	{ TYPE_INT, NULL, FALSE, 25 },	// max clump
	{ TYPE_FLOAT, NULL, FALSE, 26 },	// clump radius
	{ TYPE_INT, NULL, FALSE, 27 },	// Cutter ACtive
	{ TYPE_INT, NULL, FALSE, 28 },	// View ACtive
	{ TYPE_INT, NULL, FALSE, 29 },	// Render ACtive
	{ TYPE_INT, NULL, FALSE, 30 }	// SPline Absolute Directione


	};

static ParamBlockDescID descVer1[] = {
	{ TYPE_INT, NULL, FALSE, 0 },	// vpt count
	{ TYPE_INT, NULL, FALSE, 1 },	// rnd count	
	{ TYPE_FLOAT, NULL, TRUE, 2 },	// size
	{ TYPE_FLOAT, NULL, TRUE, 3 },	// speed
	{ TYPE_INT, NULL, TRUE, 4 },	// Cutter  Frame
	{ TYPE_FLOAT, NULL, TRUE, 5 },	// tumble
	{ TYPE_FLOAT, NULL, TRUE, 6 },	// tumble scale

	{ TYPE_INT, NULL, FALSE, 7 },	// viewport type	
	{ TYPE_INT, NULL, FALSE, 8 },	// start
	{ TYPE_INT, NULL, FALSE, 9 },	// life
	{ TYPE_INT, NULL, FALSE, 10 },	// secondary

	{ TYPE_FLOAT, NULL, TRUE, 11 },	// width
	{ TYPE_FLOAT, NULL, TRUE, 12 },	// height
	{ TYPE_INT, NULL, FALSE, 13 },	// hide emitter
	{ TYPE_FLOAT, NULL, TRUE, 14  },// falloff
	{ TYPE_FLOAT, NULL, TRUE, 15  },// secondary motion
	{ TYPE_INT, NULL, FALSE, 16 },	// Motion Transfer
	{ TYPE_INT, NULL, FALSE, 17 },	// render type
	{ TYPE_FLOAT, NULL, FALSE, 18 },	// min Length
	{ TYPE_FLOAT, NULL, FALSE, 19 },	// max Length
	{ TYPE_INT, NULL, FALSE, 20 },	// wsm
	{ TYPE_INT, NULL, FALSE, 21 },	// generate w mapping
	{ TYPE_INT, NULL, FALSE, 22 },	// vertex deformation
	{ TYPE_FLOAT, NULL, FALSE, 23 },	// Clump chance
	{ TYPE_INT, NULL, FALSE, 24 },	// min clump
	{ TYPE_INT, NULL, FALSE, 25 },	// max clump
	{ TYPE_FLOAT, NULL, FALSE, 26 },	// clump radius
	{ TYPE_INT, NULL, FALSE, 27 },	// Cutter ACtive
	{ TYPE_INT, NULL, FALSE, 28 },	// View ACtive
	{ TYPE_INT, NULL, FALSE, 29 },	// Render ACtive
	{ TYPE_INT, NULL, FALSE, 30 },	// SPline Absolute Directione
	{ TYPE_INT, NULL, FALSE, 31 },// Spline Limit
	{ TYPE_INT, NULL, TRUE, 32 }	// SPline Max Influence


	};

static ParamBlockDescID descVer2[] = {
	{ TYPE_INT, NULL, FALSE, 0 },	// vpt count
	{ TYPE_INT, NULL, FALSE, 1 },	// rnd count	
	{ TYPE_FLOAT, NULL, TRUE, 2 },	// size
	{ TYPE_FLOAT, NULL, TRUE, 3 },	// speed
	{ TYPE_INT, NULL, TRUE, 4 },	// Cutter  Frame
	{ TYPE_FLOAT, NULL, TRUE, 5 },	// tumble
	{ TYPE_FLOAT, NULL, TRUE, 6 },	// tumble scale

	{ TYPE_INT, NULL, FALSE, 7 },	// viewport type	
	{ TYPE_INT, NULL, FALSE, 8 },	// start
	{ TYPE_INT, NULL, FALSE, 9 },	// life
	{ TYPE_INT, NULL, FALSE, 10 },	// secondary

	{ TYPE_FLOAT, NULL, TRUE, 11 },	// width
	{ TYPE_FLOAT, NULL, TRUE, 12 },	// height
	{ TYPE_INT, NULL, FALSE, 13 },	// hide emitter
	{ TYPE_FLOAT, NULL, TRUE, 14  },// falloff
	{ TYPE_FLOAT, NULL, TRUE, 15  },// secondary motion
	{ TYPE_INT, NULL, FALSE, 16 },	// Motion Transfer
	{ TYPE_INT, NULL, FALSE, 17 },	// render type
	{ TYPE_FLOAT, NULL, FALSE, 18 },	// min Length
	{ TYPE_FLOAT, NULL, FALSE, 19 },	// max Length
	{ TYPE_INT, NULL, FALSE, 20 },	// wsm
	{ TYPE_INT, NULL, FALSE, 21 },	// generate w mapping
	{ TYPE_INT, NULL, FALSE, 22 },	// vertex deformation
	{ TYPE_FLOAT, NULL, FALSE, 23 },	// Clump chance
	{ TYPE_INT, NULL, FALSE, 24 },	// min clump
	{ TYPE_INT, NULL, FALSE, 25 },	// max clump
	{ TYPE_FLOAT, NULL, FALSE, 26 },	// clump radius
	{ TYPE_INT, NULL, FALSE, 27 },	// Cutter ACtive
	{ TYPE_INT, NULL, FALSE, 28 },	// View ACtive
	{ TYPE_INT, NULL, FALSE, 29 },	// Render ACtive
	{ TYPE_INT, NULL, FALSE, 30 },	// SPline Absolute Directione
	{ TYPE_INT, NULL, FALSE, 31 },// Spline Limit
	{ TYPE_INT, NULL, TRUE, 32 },	// SPline Max Influence
	{ TYPE_INT, NULL, FALSE, 33 },// Use Angle Limit
	{ TYPE_INT, NULL, TRUE, 34 },	// Angle Limit

	{ TYPE_INT, NULL, TRUE, 35 },// Filler Mult.
	{ TYPE_INT, NULL, FALSE, 36 },// Use Filler Angle Limit
	{ TYPE_INT, NULL, TRUE, 37},	// Filler Angle Limit

	{ TYPE_FLOAT, NULL, TRUE, 38},	// Filler Angle Limit

	{ TYPE_INT, NULL, TRUE, 39},	// Min Filler Seg Count
	{ TYPE_INT, NULL, TRUE, 40},	// Max Filler Seg Count


	};


static ParamBlockDescID descVer3[] = {
	{ TYPE_INT, NULL, FALSE, 0 },	// vpt count
	{ TYPE_INT, NULL, FALSE, 1 },	// rnd count	
	{ TYPE_FLOAT, NULL, TRUE, 2 },	// size
	{ TYPE_FLOAT, NULL, TRUE, 3 },	// speed
	{ TYPE_INT, NULL, TRUE, 4 },	// Cutter  Frame
	{ TYPE_FLOAT, NULL, TRUE, 5 },	// tumble
	{ TYPE_FLOAT, NULL, TRUE, 6 },	// tumble scale

	{ TYPE_INT, NULL, FALSE, 7 },	// viewport type	
	{ TYPE_INT, NULL, FALSE, 8 },	// start
	{ TYPE_INT, NULL, FALSE, 9 },	// life
	{ TYPE_INT, NULL, FALSE, 10 },	// secondary

	{ TYPE_FLOAT, NULL, TRUE, 11 },	// width
	{ TYPE_FLOAT, NULL, TRUE, 12 },	// height
	{ TYPE_INT, NULL, FALSE, 13 },	// hide emitter
	{ TYPE_FLOAT, NULL, TRUE, 14  },// falloff
	{ TYPE_FLOAT, NULL, TRUE, 15  },// settle
	{ TYPE_INT, NULL, FALSE, 16 },	// Motion Transfer
	{ TYPE_INT, NULL, FALSE, 17 },	// render type
	{ TYPE_FLOAT, NULL, FALSE, 18 },	// min Length
	{ TYPE_FLOAT, NULL, FALSE, 19 },	// max Length
	{ TYPE_INT, NULL, FALSE, 20 },	// wsm
	{ TYPE_INT, NULL, FALSE, 21 },	// generate w mapping
	{ TYPE_INT, NULL, FALSE, 22 },	// vertex deformation
	{ TYPE_FLOAT, NULL, FALSE, 23 },	// Clump chance
	{ TYPE_INT, NULL, FALSE, 24 },	// min clump
	{ TYPE_INT, NULL, FALSE, 25 },	// max clump
	{ TYPE_FLOAT, NULL, FALSE, 26 },	// clump radius
	{ TYPE_INT, NULL, FALSE, 27 },	// Cutter ACtive
	{ TYPE_INT, NULL, FALSE, 28 },	// View ACtive
	{ TYPE_INT, NULL, FALSE, 29 },	// Render ACtive
	{ TYPE_INT, NULL, FALSE, 30 },	// SPline Absolute Directione
	{ TYPE_INT, NULL, FALSE, 31 },// Spline Limit
	{ TYPE_INT, NULL, TRUE, 32 },	// SPline Max Influence
	{ TYPE_INT, NULL, FALSE, 33 },// Use Angle Limit
	{ TYPE_INT, NULL, TRUE, 34 },	// Angle Limit

	{ TYPE_INT, NULL, TRUE, 35 },// Filler Mult.
	{ TYPE_INT, NULL, FALSE, 36 },// Use Filler Angle Limit
	{ TYPE_INT, NULL, TRUE, 37},	// Filler Angle Limit

	{ TYPE_FLOAT, NULL, TRUE, 38},	// Filler Angle Limit

	{ TYPE_INT, NULL, TRUE, 39},	// Min Filler Seg Count
	{ TYPE_INT, NULL, TRUE, 40},	// Max Filler Seg Count

	{ TYPE_INT, NULL, FALSE, 41},	// Use Selected
	{ TYPE_FLOAT, NULL, FALSE, 42},	// Jitter

	};

static ParamBlockDescID descVer4[] = {
	{ TYPE_INT, NULL, FALSE, 0 },	// vpt count
	{ TYPE_INT, NULL, FALSE, 1 },	// rnd count	
	{ TYPE_FLOAT, NULL, TRUE, 2 },	// size
	{ TYPE_FLOAT, NULL, TRUE, 3 },	// speed
	{ TYPE_INT, NULL, TRUE, 4 },	// Cutter  Frame
	{ TYPE_FLOAT, NULL, TRUE, 5 },	// tumble
	{ TYPE_FLOAT, NULL, TRUE, 6 },	// tumble scale

	{ TYPE_INT, NULL, FALSE, 7 },	// viewport type	
	{ TYPE_INT, NULL, FALSE, 8 },	// start
	{ TYPE_INT, NULL, FALSE, 9 },	// life
	{ TYPE_INT, NULL, FALSE, 10 },	// secondary

	{ TYPE_FLOAT, NULL, TRUE, 11 },	// width
	{ TYPE_FLOAT, NULL, TRUE, 12 },	// height
	{ TYPE_INT, NULL, FALSE, 13 },	// hide emitter
	{ TYPE_FLOAT, NULL, TRUE, 14  },// falloff
	{ TYPE_INT, NULL, FALSE, 15  },// settle
	{ TYPE_INT, NULL, FALSE, 16 },	// Motion Transfer
	{ TYPE_INT, NULL, FALSE, 17 },	// render type
	{ TYPE_FLOAT, NULL, FALSE, 18 },	// min Length
	{ TYPE_FLOAT, NULL, FALSE, 19 },	// max Length
	{ TYPE_INT, NULL, FALSE, 20 },	// wsm
	{ TYPE_INT, NULL, FALSE, 21 },	// generate w mapping
	{ TYPE_INT, NULL, FALSE, 22 },	// vertex deformation
	{ TYPE_FLOAT, NULL, FALSE, 23 },	// Clump chance
	{ TYPE_INT, NULL, FALSE, 24 },	// min clump
	{ TYPE_INT, NULL, FALSE, 25 },	// max clump
	{ TYPE_FLOAT, NULL, FALSE, 26 },	// clump radius
	{ TYPE_INT, NULL, FALSE, 27 },	// Cutter ACtive
	{ TYPE_INT, NULL, FALSE, 28 },	// View ACtive
	{ TYPE_INT, NULL, FALSE, 29 },	// Render ACtive
	{ TYPE_INT, NULL, FALSE, 30 },	// SPline Absolute Directione
	{ TYPE_INT, NULL, FALSE, 31 },// Spline Limit
	{ TYPE_INT, NULL, TRUE, 32 },	// SPline Max Influence
	{ TYPE_INT, NULL, FALSE, 33 },// Use Angle Limit
	{ TYPE_INT, NULL, TRUE, 34 },	// Angle Limit

	{ TYPE_INT, NULL, TRUE, 35 },// Filler Mult.
	{ TYPE_INT, NULL, FALSE, 36 },// Use Filler Angle Limit
	{ TYPE_INT, NULL, TRUE, 37},	// Filler Angle Limit

	{ TYPE_FLOAT, NULL, TRUE, 38},	// Filler Angle Limit

	{ TYPE_INT, NULL, TRUE, 39},	// Min Filler Seg Count
	{ TYPE_INT, NULL, TRUE, 40},	// Max Filler Seg Count

	{ TYPE_INT, NULL, FALSE, 41},	// Use Selected
	{ TYPE_FLOAT, NULL, FALSE, 42},	// Jitter
	{ TYPE_INT, NULL, FALSE, 43},	// Settle Waves

	};



#define SNOWPARAMDESC_LENGH 44
#define PBLOCK_LENGTH_SNOW 44

#define NUM_OLDVERSIONS	4

// Current version
#define CURRENT_VERSION	11


// Array of old versions
static ParamVersionDesc versions[] = {
	ParamVersionDesc(descVer0,31,7),
	ParamVersionDesc(descVer1,32,8),
	ParamVersionDesc(descVer2,41,9),
	ParamVersionDesc(descVer3,43,10)	
	};

static ParamVersionDesc curVersionSnow(descVer4,PBLOCK_LENGTH_SNOW,CURRENT_VERSION);






//-- ParticleDlgProc ------------------------------------------------

class ParticleDlgProc : public ParamMapUserDlgProc {
	public:
		GenParticle *po;
		HWND TempHWND;

		ParticleDlgProc(GenParticle *p) {
			po=p;
			}
		BOOL DlgProc(TimeValue t,IParamMap *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
		void DeleteThis() {
			delete this;
			}
		void SetupMaxRate(HWND hWnd,IParamBlock *pblock,TimeValue t);
		void SetupConstant(HWND hWnd);
		void DumpRPS(HWND hWnd);

		void PickLengthImage(HWND hWnd);
		void RemoveLengthImage(HWND hWnd);
		void SetLengthImageName(HWND hWnd);

		void PickDistributionImage(HWND hWnd);
		void RemoveDistributionImage(HWND hWnd);
		void SetDistributionImageName(HWND hWnd);


		void SetObjectName(HWND hWnd);

		void PickWidthGraph(HWND hWnd);
		void SetWidthGraphName(HWND hWnd);

		void PickSecondaryGraph(HWND hWnd);
		void SetSecondaryGraphName(HWND hWnd);

		void PickMotionGraph(HWND hWnd);
		void SetMotionGraphName(HWND hWnd);
		
		void PickVertexDeformationGraph(HWND hWnd);
		void SetVertexDeformationGraphName(HWND hWnd);

		void PickSplineCage(HWND hWnd);
		void SetSplineCageName(HWND hWnd);

		void PickClumpingGraph(HWND hWnd);
		void SetClumpingGraphName(HWND hWnd);


	};





#define A_RENDER			A_PLUGIN1
#endif
