
#include "hair.h"
		  //

/*****************************************************************************

  Dialog stuff


******************************************************************************/
//This handles the output of particle info
//Hit Dialog

class DumpHitDialog : public HitByNameDlgCallback {
public:
	GenParticle *po;
	DumpHitDialog(GenParticle *p) {po=p;};
	TCHAR *dialogTitle() {return _T("Select objects to apply motion to");};
	TCHAR *buttonText() {return _T("Select");};
	BOOL singleSelect() {return TRUE;};
	BOOL useProc() {return TRUE;};
	void proc(INodeTab &nodeTab);
	};

void DumpHitDialog::proc(INodeTab &nodeTab)

{
 po->ReplaceReference(OBJECT_REF,nodeTab[0]);
// po->ObjectNode = nodeTab[0];
}




//This handles the output of particle info
//Hit Dialog

class MGraphHitDialog : public HitByNameDlgCallback {
public:
	GenParticle *po;
	int WhichGraph;
	MGraphHitDialog(GenParticle *p, int i) {po=p;WhichGraph = i;};
	TCHAR *dialogTitle() {return _T("Select Motion Graph Object");};
	TCHAR *buttonText() {return _T("Select");};
	BOOL singleSelect() {return TRUE;};
	BOOL useProc() {return TRUE;};
	void proc(INodeTab &nodeTab);
	BOOL useFilter() {return TRUE;};
	int filter(INode *node);
	};


int MGraphHitDialog::filter(INode *node)

{
//	Class_ID c,d;
	ObjectState os = node->EvalWorldState(po->Tempip->GetTime());
//	c = os.obj->ClassID();
//	d = MGRAPH_CLASSID;
	if (os.obj->SuperClassID()==SHAPE_CLASS_ID) 

//	return (os.obj->ClassID()==MGRAPH_CLASSID);
	return TRUE;
	else return FALSE;

}

void MGraphHitDialog::proc(INodeTab &nodeTab)

{
if (WhichGraph == WIDTHOBJECT_REF)
 po->ReplaceReference(WIDTHOBJECT_REF,nodeTab[0]);
else if (WhichGraph == SECONDARYOBJECT_REF)
 po->ReplaceReference(SECONDARYOBJECT_REF,nodeTab[0]);
else if (WhichGraph == MOTIONOBJECT_REF)
 po->ReplaceReference(MOTIONOBJECT_REF,nodeTab[0]);
else if (WhichGraph == SPLINECAGEOBJECT_REF)
 po->ReplaceReference(SPLINECAGEOBJECT_REF,nodeTab[0]);
else if (WhichGraph == VERTEXDEFORMATIONOBJECT_REF)
 po->ReplaceReference(VERTEXDEFORMATIONOBJECT_REF,nodeTab[0]);
else if (WhichGraph == CLUMPINGOBJECT_REF)
 po->ReplaceReference(CLUMPINGOBJECT_REF,nodeTab[0]);
// po->MotionGraphNode = nodeTab[0];
}


static void GetBMName(BitmapInfo& bi, TSTR &fname) { 
	TSTR fullName;
	if (bi.Name()[0]==0)
		fullName = bi.Device();
	else 
		fullName =  bi.Name();
	SplitPathFile(fullName,NULL,&fname);
	}



void ParticleDlgProc::DumpRPS(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new DumpHitDialog(po));
	SetObjectName(hWnd);
	}

void ParticleDlgProc::PickWidthGraph(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new MGraphHitDialog(po,WIDTHOBJECT_REF));
	SetWidthGraphName(hWnd);
	}


void ParticleDlgProc::SetWidthGraphName(HWND hWnd)
	{ 	
 	if (po->WidthGraphNode!=NULL){
		TSTR fname;
		fname = po->WidthGraphNode->GetName();
		SetDlgItemText(hWnd, IDC_MOTIONGRAPH_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_MOTIONGRAPH_BUTTON, GetString(IDS_RB_NONE));
		}
	}


void ParticleDlgProc::PickSecondaryGraph(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new MGraphHitDialog(po,SECONDARYOBJECT_REF));
	SetSecondaryGraphName(hWnd);
	}


void ParticleDlgProc::SetSecondaryGraphName(HWND hWnd)
	{ 	
 	if (po->SecondaryGraphNode!=NULL){
		TSTR fname;
		fname = po->SecondaryGraphNode->GetName();
		SetDlgItemText(hWnd, IDC_SECONDARYGRAPH_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_SECONDARYGRAPH_BUTTON, GetString(IDS_RB_NONE));
		}
	}

void ParticleDlgProc::PickClumpingGraph(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new MGraphHitDialog(po,CLUMPINGOBJECT_REF));
	SetClumpingGraphName(hWnd);
	}


void ParticleDlgProc::SetClumpingGraphName(HWND hWnd)
	{ 	
 	if (po->ClumpingGraphNode!=NULL){
		TSTR fname;
		fname = po->ClumpingGraphNode->GetName();
		SetDlgItemText(hWnd, IDC_CLUMPGRAPH_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_CLUMPGRAPH_BUTTON, GetString(IDS_RB_NONE));
		}
	}



void ParticleDlgProc::PickMotionGraph(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new MGraphHitDialog(po,MOTIONOBJECT_REF));
	SetMotionGraphName(hWnd);
	}


void ParticleDlgProc::SetMotionGraphName(HWND hWnd)
	{ 	
 	if (po->MotionGraphNode!=NULL){
		TSTR fname;
		fname = po->MotionGraphNode->GetName();
		SetDlgItemText(hWnd, IDC_MTRANSFERGRAPH_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_MTRANSFERGRAPH_BUTTON, GetString(IDS_RB_NONE));
		}
	}


void ParticleDlgProc::PickVertexDeformationGraph(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new MGraphHitDialog(po,VERTEXDEFORMATIONOBJECT_REF));
	SetVertexDeformationGraphName(hWnd);
	}


void ParticleDlgProc::SetVertexDeformationGraphName(HWND hWnd)
	{ 	
 	if (po->VertexDeformationGraphNode!=NULL){
		TSTR fname;
		fname = po->VertexDeformationGraphNode->GetName();
		SetDlgItemText(hWnd, IDC_VERTEXDEFORMATIONGRAPH_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_VERTEXDEFORMATIONGRAPH_BUTTON, GetString(IDS_RB_NONE));
		}
	}


void ParticleDlgProc::PickSplineCage(HWND hWnd)
	{
//pick nodes to apply motion to 
	po->Tempip->DoHitByNameDialog(new MGraphHitDialog(po,SPLINECAGEOBJECT_REF));
	SetSplineCageName(hWnd);
	}


void ParticleDlgProc::SetSplineCageName(HWND hWnd)
	{ 	
 	if (po->SplineCageNode!=NULL){
		TSTR fname;
		fname = po->SplineCageNode->GetName();
		SetDlgItemText(hWnd, IDC_SPLINECAGE_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_SPLINECAGE_BUTTON, GetString(IDS_RB_NONE));
		}
	}




void ParticleDlgProc::SetLengthImageName(HWND hWnd)
	{ 	
 	if (po&&po->thebmLength){
		TSTR fname;
		GetBMName(po->biLength, fname); 
		SetDlgItemText(hWnd, IDC_LENGTH_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_LENGTH_BUTTON, GetString(IDS_RB_NONE));
		}
	}


void ParticleDlgProc::SetObjectName(HWND hWnd)
	{ 	
 	if (po->ObjectNode!=NULL){
		TSTR fname;
		fname = po->ObjectNode->GetName();
		SetDlgItemText(hWnd, IDC_DUMP_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_DUMP_BUTTON, GetString(IDS_RB_NONE));
		}
	}


void ParticleDlgProc::RemoveLengthImage(HWND hWnd)
	{
	po->biLength.SetName(_T(""));
	po->FreeBitmap();
	po->NotifyDependents(FOREVER,PART_GEOM,REFMSG_CHANGE);
	SetLengthImageName(hWnd);
	}



void ParticleDlgProc::PickLengthImage(HWND hWnd)
	{	
	BitmapInfo *bi = &po->biLength;
	if(TheManager->SelectFileInputEx(
		bi, hWnd, GetString(IDS_RB_SELECTDISPIMAGE)))
		{
			po->FreeBitmap();
			po->LoadBitmap();
			po->NotifyDependents(FOREVER,PART_GEOM,REFMSG_CHANGE);

		} 
		SetLengthImageName(hWnd);
		po->BuildStartingPos(TRUE,0);
	}



void ParticleDlgProc::SetDistributionImageName(HWND hWnd)
	{ 	
 	if (po&&po->thebmDistribution){
		TSTR fname;
		GetBMName(po->biDistribution, fname); 
		SetDlgItemText(hWnd, IDC_DISTRIBUTION_BUTTON,fname);
	} else {
		SetDlgItemText(hWnd, IDC_DISTRIBUTION_BUTTON, GetString(IDS_RB_NONE));
		}
	}

void ParticleDlgProc::RemoveDistributionImage(HWND hWnd)
	{
	po->biDistribution.SetName(_T(""));
	po->FreeDistributionBitmap();
	po->NotifyDependents(FOREVER,PART_GEOM,REFMSG_CHANGE);
	SetDistributionImageName(hWnd);
	}



void ParticleDlgProc::PickDistributionImage(HWND hWnd)
	{	
	BitmapInfo *bi = &po->biDistribution;
	if(TheManager->SelectFileInputEx(
		bi, hWnd, GetString(IDS_RB_SELECTDISPIMAGE)))
		{
 			po->FreeDistributionBitmap();
			po->LoadDistributionBitmap();
			po->NotifyDependents(FOREVER,PART_GEOM,REFMSG_CHANGE);

		} 
		SetDistributionImageName(hWnd);
		po->BuildStartingPos(TRUE,0);
	}






void ParticleDlgProc::SetupMaxRate(HWND hWnd,IParamBlock *pblock,TimeValue t)
	{
	int count, life;
	pblock->GetValue(PB_RNDPARTICLES,t,count,FOREVER);
	pblock->GetValue(PB_SEGCOUNT,t,life,FOREVER);
/*	if (TestAFlag(A_RENDER)) 
		life = life *2;
*/
	if (life <= 0) life = 1;
	TSTR buf;
	buf.printf(_T("%.1f"),(float)GetTicksPerFrame()*float(count)/float(life));
//	SetWindowText(GetDlgItem(hWnd,IDC_PARTICLE_MAXRATE),buf);
	}

void ParticleDlgProc::SetupConstant(HWND hWnd)
	{
//SpinnerControl *spin = GetISpinner(GetDlgItem(hWnd,IDC_PARTICLE_BIRTHRATESPIN));
//if (IsDlgButtonChecked(hWnd,IDC_PARTICLE_CONSTANTRATE)) {
//		spin->Disable();
//	} else {
//		spin->Enable();
//		}
//	ReleaseISpinner(spin);
	}

BOOL ParticleDlgProc::DlgProc(
		TimeValue t,IParamMap *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
	{
	switch (msg) {
		case WM_INITDIALOG:
			SetupMaxRate(hWnd,(IParamBlock*)map->GetParamBlock(),t);
			SetupConstant(hWnd);
			SetLengthImageName(hWnd);
			SetDistributionImageName(hWnd);
			SetObjectName(hWnd);

			SetWidthGraphName(hWnd);
			SetSecondaryGraphName(hWnd);
			SetMotionGraphName(hWnd);
			SetSplineCageName(hWnd);

			SetClumpingGraphName(hWnd);


			SetVertexDeformationGraphName(hWnd);

			break;			
			
		case CC_SPINNER_CHANGE:
			switch (LOWORD(wParam)) {
				case IDC_VPT_PARTICLESSPIN:
				case IDC_PARTICLE_LIFESPIN: 
					SetupMaxRate(hWnd,(IParamBlock*)map->GetParamBlock(),t);
					break;					
				}
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_PARTICLE_CONSTANTRATE:
					SetupConstant(hWnd);
					break;	
				case IDC_DUMP_BUTTON :
					DumpRPS(hWnd);
					break;

				case IDC_LENGTH_BUTTON:
					PickLengthImage(hWnd);
					break;
				case IDC_DELLENGTH_BUTTON:
					RemoveLengthImage(hWnd);
					break;

				case IDC_DISTRIBUTION_BUTTON:
					PickDistributionImage(hWnd);
					break;
				case IDC_DELDISTRiBUTION_BUTTON:
 					RemoveDistributionImage(hWnd);
					break;


				case IDC_MOTIONGRAPH_BUTTON:
					PickWidthGraph(hWnd);
					break;
				case IDC_DELMGRAPH_BUTTON:
					po->DeleteReference(WIDTHOBJECT_REF);
					SetWidthGraphName(hWnd);
					break;

				case IDC_MTRANSFERGRAPH_BUTTON:
					PickMotionGraph(hWnd);
					break;
				case IDC_DELMTGRAPH_BUTTON:
					po->DeleteReference(MOTIONOBJECT_REF);
					SetMotionGraphName(hWnd);
					break;

				case IDC_SECONDARYGRAPH_BUTTON:
					PickSecondaryGraph(hWnd);
					break;
				case IDC_DELSGRAPH_BUTTON:
					po->DeleteReference(SECONDARYOBJECT_REF);
					SetSecondaryGraphName(hWnd);
					break;

				case IDC_VERTEXDEFORMATIONGRAPH_BUTTON:
					PickVertexDeformationGraph(hWnd);
					break;
				case IDC_DELVDGRAPH_BUTTON:
					po->DeleteReference(VERTEXDEFORMATIONOBJECT_REF);
					SetVertexDeformationGraphName(hWnd);
					break;


				case IDC_SPLINECAGE_BUTTON:
					PickSplineCage(hWnd);
					break;
				case IDC_DELSPLINECAGE_BUTTON:
					po->DeleteReference(SPLINECAGEOBJECT_REF);
					SetSplineCageName(hWnd);
					break;

				case IDC_CLUMPGRAPH_BUTTON:
					PickClumpingGraph(hWnd);
					break;
				case IDC_DELCLUMPGRAPH_BUTTON:
					po->DeleteReference(CLUMPINGOBJECT_REF);
					SetClumpingGraphName(hWnd);
					break;




				}
			break;	
		}
	return FALSE;
	}


/*****************************************************************************

  General maintence stuff


******************************************************************************/




//--- GenParticle Methods--------------------------------------------

GenParticle::GenParticle(BOOL rain)
	{
	int length = PBLOCK_LENGTH_SNOW;
	Tempip = NULL;
	MakeRefByID(FOREVER, 0, CreateParameterBlock(descVer4, length, CURRENT_VERSION));
	assert(pblock);
	
	pblock->SetValue(PB_VPTPARTICLES,0,100);
	pblock->SetValue(PB_RNDPARTICLES,0,100);
	pblock->SetValue(PB_DROPSIZE,0,2.0f);
	pblock->SetValue(PB_SPEED,0,10.0f);
	pblock->SetValue(PB_DISPTYPE,0,0);
	pblock->SetValue(PB_STARTTIME,0,0);
	pblock->SetValue(PB_SEGCOUNT,0,30);
//block->SetValue(PB_CONSTANT,0,1);
	pblock->SetValue(PB_WATJE_FALLOFF,0,1.0f);
	pblock->SetValue(PB_SETTLE,0,40);
	pblock->SetValue(PB_WAVES,0,4);

	pblock->SetValue(PB_LENGTH_MIN,0,30.0f);
	pblock->SetValue(PB_LENGTH_MAX,0,30.0f);

	pblock->SetValue(PB_RENDERACTIVE,0,1);
	pblock->SetValue(PB_VIEWACTIVE,0,1);

	pblock->SetValue(PB_SCALE,0,1.0f);
	stepSize = 0;

	DVerts.ZeroCount();

	ObjectNode = NULL;
	WidthGraphNode = NULL;
	SecondaryGraphNode = NULL;
	MotionGraphNode = NULL;
	VertexDeformationGraphNode = NULL;
	SplineCageNode = NULL;
	ClumpingGraphNode = NULL;

	thebmLength = NULL;
	thebmDistribution = NULL;


	PrevEmitterTM.IdentityMatrix();
	UseJiggle = 0;
	SwingTime = 0;
	JiggleTime = 0;
	Still = TRUE;
	PrevStill = TRUE;


	}


GenParticle::~GenParticle()
	{
	FreeBitmap();
	FreeDistributionBitmap();
	}



class EmitterCreateCallback : public CreateMouseCallBack {
	public:
		GenParticle *rain;
		Point3 p0,p1;
		IPoint2 sp0, sp1;
		int proc( ViewExp *vpt,int msg, int point, int flags, IPoint2 m, Matrix3& mat);
	};

int EmitterCreateCallback::proc(
		ViewExp *vpt,int msg, int point, int flags, IPoint2 m, Matrix3& mat)
	{
	if (msg==MOUSE_POINT||msg==MOUSE_MOVE) {
		switch(point)  {
			case 0:
				sp0 = m;
				p0  = vpt->SnapPoint(m,m,NULL,SNAP_IN_PLANE);
				mat.SetTrans(p0);
				rain->pblock->SetValue(PB_EMITTERWIDTH,0,0.01f);
				rain->pblock->SetValue(PB_EMITTERHEIGHT,0,0.01f);
				rain->pmapParam->Invalidate();
				break;

			case 1: {
				mat.IdentityMatrix();
				sp1 = m;
				p1  = vpt->SnapPoint(m,m,NULL,SNAP_IN_PLANE);
				Point3 center = (p0+p1)/float(2);
				mat.SetTrans(center);
				float width, height ;
				width = (float)fabs(p1.x-p0.x);
				rain->pblock->SetValue(PB_EMITTERWIDTH,0,width);
				height = (float)fabs(p1.y-p0.y);
				rain->pblock->SetValue(PB_EMITTERHEIGHT,0,height);
				rain->pmapParam->Invalidate();

				if (msg==MOUSE_POINT) {
					if (Length(m-sp0)<3 || Length(p1-p0)<0.1f) {						
						return CREATE_ABORT;
					} else {
						return CREATE_STOP;
						}
					}
				break;
				}

			}
	} else {
		if (msg == MOUSE_ABORT)
			return CREATE_ABORT;
		}
	return 1;
	}

static EmitterCreateCallback emitterCallback;

CreateMouseCallBack* GenParticle::GetCreateMouseCallBack() 
	{
	emitterCallback.rain = this;
	return &emitterCallback;
	}

void GenParticle::InvalidateUI()
	{
	if (pmapParam) pmapParam->Invalidate();
	}

BOOL GenParticle::EmitterVisible()
	{
	int hide;
	pblock->GetValue(PB_HIDEEMITTER,0,hide,FOREVER);
	return !hide;
	}

ParamDimension *GenParticle::GetParameterDim(int pbIndex) 
	{
	switch (pbIndex) {
		case PB_EMITTERWIDTH:
		case PB_EMITTERHEIGHT:
		case PB_DROPSIZE:		return stdWorldDim;

		case PB_STARTTIME:	return stdTimeDim;
		case PB_SEGCOUNT:		
		
//		case PB_BIRTHRATE:		return &theBirthRateDim;
		default: return defaultDim;
		}
	}

TSTR GenParticle::GetParameterName(int pbIndex)
	{
	switch (pbIndex) {
		case PB_VPTPARTICLES:	return GetString(IDS_RB_VIEWPARTICLES);		
		case PB_SPEED:			return GetString(IDS_RB_SPEED);
		case PB_CUTTERFRAME:	return GetString(IDS_RB_VARIATION);
		case PB_STARTTIME:		return GetString(IDS_RB_STARTTIME);
		case PB_SEGCOUNT:		return GetString(IDS_RB_LIFETIME);
		case PB_EMITTERWIDTH:	return GetString(IDS_RB_WIDTH);
		case PB_EMITTERHEIGHT:	return GetString(IDS_RB_LENGTH);
		case PB_TUMBLE:			return GetString(IDS_RB_TUMBLE);
		case PB_SCALE:			return GetString(IDS_RB_TUMBLERATE);
		case PB_DROPSIZE:		return GetString(IDS_RB_FLAKESIZE);
				
			

		default: 				return TSTR(_T(""));
		}
	}





void GenParticle::GetWorldBoundBox(
		TimeValue t, INode *inode, ViewExp* vpt, Box3& box)
	{
	int type, life;
	pblock->GetValue(PB_DISPTYPE,0,type,FOREVER);
	pblock->GetValue(PB_SEGCOUNT,0,life,FOREVER);
	BOOL rain = FALSE;
	
	if (type==0) {
		Box3 pbox;
		Matrix3 mat = inode->GetObjTMBeforeWSM(t);	
		UpdateMesh(t);
		box  = mesh.getBoundingBox();
		box  = box * mat;
		for (int i=0; i<parts.points.Count(); i++) {
			if (!parts.Alive(i)) {
				continue;
				}
			float sz = 
				CompParticleSize(t,parts.ages[i],life,parts.size);			
			
			Point3 pt = parts.points[i];
			pbox += pt;
			if (rain) {				
				pbox += pt - parts.vels[i] * RAINSIZEFACTOR * sz;
			} else {
				pbox += pt + Point3( sz, 0.0f, 0.0f);
				pbox += pt + Point3(-sz, 0.0f, 0.0f);
				pbox += pt + Point3( 0.0f, sz, 0.0f);
				pbox += pt + Point3( 0.0f,-sz, 0.0f);
				pbox += pt + Point3( 0.0f, 0.0f, sz);
				pbox += pt + Point3( 0.0f, 0.0f,-sz);
				}
			}
		if (!pbox.IsEmpty()) box += pbox;
	} else {
		SimpleParticle::GetWorldBoundBox(t,inode,vpt,box);
		}
	}





void GenParticle::BeginEditParams(
		IObjParam *ip, ULONG flags,Animatable *prev)
	{
	SimpleParticle::BeginEditParams(ip,flags,prev);
	Tempip = ip;
	if (pmapParam) {
		pmapParam->SetParamBlock(pblock);
	} else {		
		
		pmapParam = CreateCPParamMap(
			ParamDesc(),DescCount(),
			pblock,
			ip,
			hInstance,
			MAKEINTRESOURCE(DialogID()),
			GetString(IDS_RB_PARAMETERS),
			0);		
		}
	pmapParam->SetUserDlgProc(new ParticleDlgProc(this));
	}

void GenParticle::EndEditParams(
		IObjParam *ip, ULONG flags,Animatable *next)
	{
	SimpleParticle::EndEditParams(ip,flags,next);

	if (flags&END_EDIT_REMOVEUI) {
		DestroyCPParamMap(pmapParam);
		pmapParam  = NULL;
		}
	}

void GenParticle::MapKeys(TimeMap *map,DWORD flags)
	{
	TimeValue start, life;
	pblock->GetValue(PB_STARTTIME,0,start,FOREVER);
	pblock->GetValue(PB_SEGCOUNT,0,life,FOREVER);
	if (TestAFlag(A_RENDER)) 
		life = life *2;


	start = map->map(start);
	life  = map->map(life);

	pblock->SetValue(PB_STARTTIME,0,start);
	pblock->SetValue(PB_SEGCOUNT,0,life);
	}

Interval GenParticle::GetValidity(TimeValue t)
	{
	// For now...
	return Interval(t,t);
	}

void GenParticle::BuildEmitter(TimeValue t, Mesh& amesh)
	{
	float width, height,length;
	float u;

	#define NUM_SEGS	16


	mvalid = FOREVER;
	pblock->GetValue(PB_EMITTERWIDTH,t,width,mvalid);
	pblock->GetValue(PB_EMITTERHEIGHT,t,height,mvalid);
	width  *= 0.5f;
	height *= 0.5f;

	if (width>height)
		length = width;
	   else length = height;


	mesh.setNumVerts(3*NUM_SEGS+1);
	mesh.setNumFaces(3*NUM_SEGS);

	for (int i=0; i<NUM_SEGS; i++) {
			u = float(i)/float(NUM_SEGS) * TWOPI;
			mesh.setVert(i, Point3((float)cos(u) * length, (float)sin(u) * length, 0.0f));
			}
	for (i=0; i<NUM_SEGS; i++) {
			u = float(i)/float(NUM_SEGS) * TWOPI;
			mesh.setVert(i+NUM_SEGS, Point3(0.0f, (float)cos(u) * length, (float)sin(u) * length));
			}
	for (i=0; i<NUM_SEGS; i++) {
			u = float(i)/float(NUM_SEGS) * TWOPI;
			mesh.setVert(i+2*NUM_SEGS, Point3((float)cos(u) * length, 0.0f, (float)sin(u) * length));
			}		
	mesh.setVert(3*NUM_SEGS, Point3(0.0f, 0.0f, 0.0f));
		
	for (i=0; i<3*NUM_SEGS; i++) {
			int i1 = i+1;
			if (i1%NUM_SEGS==0) i1 -= NUM_SEGS;
			mesh.faces[i].setEdgeVisFlags(1,0,0);
			mesh.faces[i].setSmGroup(1);
			mesh.faces[i].setVerts(i,i1,3*NUM_SEGS);
			}


	mesh.InvalidateGeomCache();
	}




RefTargetHandle GenParticle::GetReference(int i) 
	{
	switch (i) {
		case PBLOCK_REF:	return pblock;		
		case WIDTHOBJECT_REF: return WidthGraphNode;
		case OBJECT_REF:    return ObjectNode;
		case SECONDARYOBJECT_REF:    return SecondaryGraphNode;
		case MOTIONOBJECT_REF:    return MotionGraphNode;
		case VERTEXDEFORMATIONOBJECT_REF:    return VertexDeformationGraphNode;
		case SPLINECAGEOBJECT_REF:    return SplineCageNode;
		case CLUMPINGOBJECT_REF:    return ClumpingGraphNode;

		default: return NULL;
//			if (i>=OBJECT_REF) return nodes[i-OBJECT_REF];
//			else return NULL;			
		}
	}

void GenParticle::SetReference(int i, RefTargetHandle rtarg) 
	{	
 	switch (i) {
		case PBLOCK_REF:	      pblock = (IParamBlock*)rtarg; break;
		case OBJECT_REF:          ObjectNode = (INode*)rtarg; break;
		case WIDTHOBJECT_REF:     WidthGraphNode = (INode*)rtarg;  break;
		case SECONDARYOBJECT_REF: SecondaryGraphNode = (INode*)rtarg;  break;
		case MOTIONOBJECT_REF:    MotionGraphNode = (INode*)rtarg;  break;
		case VERTEXDEFORMATIONOBJECT_REF:    VertexDeformationGraphNode = (INode*)rtarg;  break;
		case SPLINECAGEOBJECT_REF:    SplineCageNode = (INode*)rtarg;  break;
		case CLUMPINGOBJECT_REF: ClumpingGraphNode = (INode*)rtarg;  break;

//			if (i>=OBJECT_REF) 
//			break;
		}
	}

RefResult GenParticle::NotifyRefChanged(
		Interval changeInt, RefTargetHandle hTarget,
		PartID& partID,  RefMessage message) 

	{

	if (hTarget==pblock)
		SimpleParticle::NotifyRefChanged(changeInt,hTarget,partID,message);
	else 
		{

		switch (message) {
			case REFMSG_TARGET_DELETED: {
				if (hTarget==ObjectNode) {
					ObjectNode = NULL;					
					}
				else if (hTarget==WidthGraphNode) {
					WidthGraphNode = NULL;					
					}
				else if (hTarget==SecondaryGraphNode) {
					SecondaryGraphNode = NULL;					
					}
				else if (hTarget==MotionGraphNode) {
					MotionGraphNode = NULL;					
					}
				else if (hTarget==VertexDeformationGraphNode) {
					VertexDeformationGraphNode = NULL;					
					}
				else if (hTarget==SplineCageNode) {
					SplineCageNode = NULL;					
					}
				else if (hTarget==ClumpingGraphNode) {
					ClumpingGraphNode = NULL;					
					}

				break;
				}

//		case REFMSG_CHANGE:
//			if (hTarget==ObjectNode) 
//				{
//				valid=1;
//				}
			break;

			case REFMSG_NODE_NAMECHANGE:
//			if (dlg) dlg->UpdateNames();
				break;

/*			case REFMSG_GET_PARAM_DIM: {
				GetParamDim *gpd = (GetParamDim*)partID;
				switch (gpd->index) {			
//				case PB_COLOR1: 	gpd->dim = stdColor255Dim; break;
//				case PB_COLOR2: 	gpd->dim = stdColor255Dim; break;
//				case PB_COLOR3: 	gpd->dim = stdColor255Dim; break;
					default: 			gpd->dim = defaultDim;
					}
				return REF_STOP; 
				}

			case REFMSG_GET_PARAM_NAME: {
				GetParamName *gpn = (GetParamName*)partID;
				switch (gpn->index) {				
//				case PB_COLOR1:		gpn->name = GetString(IDS_RB_INNERCOLOR); break;
//				case PB_COLOR2:		gpn->name = GetString(IDS_RB_OUTERCOLOR); break;
//				case PB_COLOR3:		gpn->name = GetString(IDS_RB_SMOKECOLOR); break;
//				case PB_STRETCH:	gpn->name = GetString(IDS_RB_STRETCH); break;
//				case PB_REGULARITY:	gpn->name = GetString(IDS_RB_REGULARITY); break;
//				case PB_SCALE:		gpn->name = GetString(IDS_RB_FLAMESIZE); break;
//				case PB_LEVELS:		gpn->name = GetString(IDS_RB_FLAMEDETAIL); break;
//				case PB_DENSITY:	gpn->name = GetString(IDS_RB_DENSITY); break;				
//				case PB_PHASE:		gpn->name = GetString(IDS_RB_PHASE); break;
//				case PB_DRIFT:		gpn->name = GetString(IDS_RB_DRIFT); break;
//				case PB_PARTICLE_SIZE:	gpn->name = GetString(IDS_RB_PARTICLE_SIZE); break;
//				case PB_PARTICLE_LIFE:	gpn->name = GetString(IDS_RB_PARTICLE_LIFE); break;
					default:			gpn->name = _T("?????"); break;
					}
				return REF_STOP; 

				}	
*/
			}
		}
	return REF_SUCCEED;
	}




class ParticlePostLoadCallback : public PostLoadCallback {
	public:
		ParamBlockPLCB *cb;
		ParticlePostLoadCallback(ParamBlockPLCB *c) {cb=c;}
		void proc(ILoad *iload) {
			DWORD oldVer = ((GenParticle*)(cb->targ))->pblock->GetVersion();
			ReferenceTarget *targ = cb->targ;
			cb->proc(iload);
			if (oldVer==0) {				
//		((GenParticle*)targ)->pblock->SetValue(PB_CONSTANT,0,1);
				}
			if (oldVer<3) {
				// Set render particles to vpt particles.
				int vc;				
				((GenParticle*)targ)->pblock->GetValue(PB_VPTPARTICLES,0,vc,FOREVER);
				((GenParticle*)targ)->pblock->SetValue(PB_RNDPARTICLES,0,vc);
				}
			delete this;
			}
	};

IOResult GenParticle::Load(ILoad *iload)
	{
	IOResult res = IO_OK;
	iload->RegisterPostLoadCallback(
			new ParticlePostLoadCallback(
				new ParamBlockPLCB(versions,NUM_OLDVERSIONS,&curVersionSnow,this,0)));

	while (IO_OK==(res=iload->OpenChunk())) {
		switch (iload->CurChunkID()) {
			case MAPNAME_LENGTH_CHUNK: {
				TCHAR *buf;
				res=iload->ReadWStringChunk(&buf);
				biLength.SetName(buf);
				FreeBitmap();
				LoadBitmap();
				break;
				}
			case BMIO_LENGTH_CHUNK: {
				res = biLength.Load(iload);
				FreeBitmap();
				LoadBitmap();
				break;
				}
			case MAPNAME_DISTRIBUTION_CHUNK: {
				TCHAR *buf;
				res=iload->ReadWStringChunk(&buf);
				biDistribution.SetName(buf);
				FreeDistributionBitmap();
				LoadDistributionBitmap();
				break;
				}
			case BMIO_DISTRIBUTION_CHUNK: {
				res = biDistribution.Load(iload);
				FreeDistributionBitmap();
				LoadDistributionBitmap();
				break;
				}
			}
		iload->CloseChunk();
		if (res!=IO_OK)  return res;
		}	
	
//	return IO_OK;

		
	return IO_OK;
	}

IOResult GenParticle::Save(ISave *isave)
	{
	SimpleParticle::Save(isave);

	if (thebmLength) {
		isave->BeginChunk(BMIO_LENGTH_CHUNK);
		biLength.Save(isave);
		isave->EndChunk();
		}


	if (thebmDistribution) {
		isave->BeginChunk(BMIO_DISTRIBUTION_CHUNK);
		biDistribution.Save(isave);
		isave->EndChunk();
		}

	return IO_OK;
	}


RefTargetHandle SnowParticle::Clone(RemapDir& remap) 
	{
	SnowParticle* newob = new SnowParticle();	
	newob->ReplaceReference(0,pblock->Clone(remap));	
	newob->mvalid.SetEmpty();	
	newob->tvalid = FALSE;
	return newob;
	}




// RB 3-38-96
// Changed render begin and end to always invalidate the particles.
// This ensures that the particles will always update completely
// once before a rendering session and allows the integration
// step size to change to the size of a field instead of a frame.

int GenParticle::RenderBegin(TimeValue t, ULONG flags)
	{
	SetAFlag(A_RENDER);
	ParticleInvalid();		
	NotifyDependents(FOREVER,PART_ALL,REFMSG_CHANGE);
	return 0;

#if 0
	int vc, rc;
	pblock->GetValue(PB_VPTPARTICLES,0,vc,FOREVER);
	pblock->GetValue(PB_RNDPARTICLES,0,rc,FOREVER);
	SetAFlag(A_RENDER);
	if (vc!=rc) {
		ParticleInvalid();		
		NotifyDependents(FOREVER,PART_ALL,REFMSG_CHANGE);
		}
	return 0;
#endif
	}

int GenParticle::RenderEnd(TimeValue t)
	{
	ClearAFlag(A_RENDER);
	ParticleInvalid();		
	NotifyDependents(FOREVER,PART_ALL,REFMSG_CHANGE);
	return 0;

#if 0
	int vc, rc;
	pblock->GetValue(PB_VPTPARTICLES,0,vc,FOREVER);
	pblock->GetValue(PB_RNDPARTICLES,0,rc,FOREVER);
	ClearAFlag(A_RENDER);
	if (vc!=rc) {
		ParticleInvalid();		
		NotifyDependents(FOREVER,PART_ALL,REFMSG_CHANGE);
		}
	return 0;
#endif
	}


//--- Snow particle -----------------------------------------------

SnowParticle::SnowParticle() : GenParticle(FALSE)
	{
//	pblock->SetValue(PB_VARIATION,0,2.0f);
	Starting.ZeroCount();
	swidth = 0.0f;
	sheight = 0.0f;
	NumberStrands = 0;
	LastParticle = 0;
	HCount = 0;

	}

ParamUIDesc *SnowParticle::ParamDesc()
	{
	return descParamSnow;
	}

int SnowParticle::DescCount()
	{
	return SNOWPARAMDESC_LENGH;
	}

void SnowParticle::UpdateParticles(TimeValue t,INode *node)
	{
	// Make sure the snow draw callback is up to date.
	pblock->GetValue(PB_TUMBLE,t,theSnowDraw.tumble,FOREVER);
	pblock->GetValue(PB_SCALE,t,theSnowDraw.scale,FOREVER);	

	theSnowDraw.scale /= 50.0f;

//DebugPrint("NumberStrands %d \n LastParticle %d \n",NumberStrands,LastParticle);


	GenParticle::UpdateParticles(t,node);
	theSnowDraw.LParticle = LastParticle;
	theSnowDraw.NParticles = NumberStrands;
	theSnowDraw.Alive = CountLive();

	}
