#include "prim.h"
#include "iparamm.h"
#include "Simpobj.h"
#include "texutil.h"
#include "istdplug.h"
#include "decomp.h"
#include "trig.h"
#include "bmmlib.h"
#include "splshape.h"
#include "simpspl.h"

#include "hair.h"


float GenParticle::GetGraph(int Index, TimeValue t, float pos)

{

	
	float percent = 0.0f;
	float length,width,sfactor,dist;
	float r,cr;
	Point3 CurrentPoint;

	

	SplineShape *MGraph;// = (SplineShape *)os->obj;


//	RectangleObject *MGraph;
	ObjectState os;
	if (Index == WIDTHOBJECT_REF)
		os = WidthGraphNode->EvalWorldState(t);
	else if (Index == SECONDARYOBJECT_REF)
		os = SecondaryGraphNode->EvalWorldState(t);
	else if (Index == MOTIONOBJECT_REF)
		os = MotionGraphNode->EvalWorldState(t);
	else if (Index == VERTEXDEFORMATIONOBJECT_REF)
		os = VertexDeformationGraphNode->EvalWorldState(t);
	else if (Index == CLUMPINGOBJECT_REF)
		os = ClumpingGraphNode->EvalWorldState(t);


//	MGraph = (RectangleObject*)os.obj;
	MGraph = (SplineShape*)os.obj;

	// Get a hold of the parameter block
/*	IParamArray *MGraphParams = os.obj->GetParamBlock();
	assert(MGraphParams);

	MGraphParams->GetValue(PB_LENGTH, t, length, FOREVER);
	MGraphParams->GetValue(PB_WIDTH, t, width, FOREVER);
	MGraphParams->GetValue(PB_SFACTOR, t, sfactor, FOREVER);
*/

	sfactor = 1.0f;

	Spline3D *spline = MGraph->shape.GetSpline(0);

	Point3  a,b;
	a = spline->GetKnotPoint(0);
	b = spline->GetKnotPoint(1);
	length = a.y-b.y;

	a = spline->GetKnotPoint(1);
	b = spline->GetKnotPoint(2);
 	width = b.x - a.x;

	spline = MGraph->shape.GetSpline(1);


	pos *= length;

	r = 0.5f;
	cr = 0.5f;
	CurrentPoint = spline->InterpCurve3D(cr);
	dist = pos - (CurrentPoint.x+(width/2));

	while ((fabs(dist) > 0.0001) && (r>0.0001))
		{
		r = r/2.0f;			

		if (dist<0.0f)
			cr -= r;
			else cr += r;

		CurrentPoint = spline->InterpCurve3D(cr);
		dist = pos - (CurrentPoint.x+(width/2));

		}

	CurrentPoint = spline->InterpCurve3D(cr);
	percent = CurrentPoint.y+(length/2);
	return (percent/length);


}

void GenParticle::LoadBitmap() 
	{
	if (biLength.Name()[0]==0&&biLength.Device()[0]==0)
		return;
	thebmLength = TheManager->Load(&biLength);
	}

void GenParticle::FreeBitmap()
	{
	if (thebmLength) {
		thebmLength->DeleteThis();;
		thebmLength = NULL;
		}
	}

void GenParticle::LoadDistributionBitmap() 
	{
	if (biDistribution.Name()[0]==0&&biDistribution.Device()[0]==0)
		return;
	thebmDistribution = TheManager->Load(&biDistribution);
	}

void GenParticle::FreeDistributionBitmap()
	{
	if (thebmDistribution) {
		thebmDistribution->DeleteThis();;
		thebmDistribution = NULL;
		}
	}



void GenParticle::SetLengthImageTime(TimeValue t)
	{
	if (thebmLength) {
		int length = biLength.LastFrame()-biLength.FirstFrame()+1;
		int frame = (t/GetTicksPerFrame())%length + biLength.FirstFrame();
		biLength.SetCurrentFrame(frame);
		thebmLength->GoTo(&biLength);
		}
	if (thebmDistribution) {
		int length = biDistribution.LastFrame()-biDistribution.FirstFrame()+1;
		int frame = (t/GetTicksPerFrame())%length + biDistribution.FirstFrame();
		biDistribution.SetCurrentFrame(frame);
		thebmDistribution->GoTo(&biDistribution);
		}
	}


float GenParticle::GetLengthPixel(float u, float v)
	{
	if (!thebmLength) return 1.0f;
	BMM_Color_64 c;
	int w = thebmLength->Width()-1;
	int h = thebmLength->Height()-1;
	int x = (int)(frac(u)*(float)w);
	int y = h - (int)(frac(v)*(float)h);
	thebmLength->GetLinearPixels(x,y,1,&c);
	float f = float(c.r)/float(0xFFFF) * 0.299f;
	f      += float(c.g)/float(0xFFFF) * 0.587f;
	f      += float(c.b)/float(0xFFFF) * 0.114f;
	return f;
	}


float GenParticle::GetDistributionPixel(float u, float v)
	{
	if (!thebmDistribution) return 1.0f;
	BMM_Color_64 c;
	int w = thebmDistribution->Width()-1;
	int h = thebmDistribution->Height()-1;
	int x = (int)(frac(u)*(float)w);
	int y = h - (int)(frac(v)*(float)h);
	thebmDistribution->GetLinearPixels(x,y,1,&c);
	float f = float(c.r)/float(0xFFFF) * 0.299f;
	f      += float(c.g)/float(0xFFFF) * 0.587f;
	f      += float(c.b)/float(0xFFFF) * 0.114f;
	return f;
	}

